//  Clint - Source code checker for C++
//  Copyright (C) 2001  David Pashley
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __PYTHONRULE_H__
#define __PYTHONRULE_H__

#include "rule.h"
#include <python.h>

using python::Object;
using python::Tuple;
using python::String;

class PythonRule : public Rule {
   private:
      python::Python *interpreter;
      python::Module m_class;
   public:
      PythonRule();
      void initialize();
      void finalize();
      void pre_cpp(std::string line);
      void post_cpp(std::string line);
      void load_module(std::string filename);
};

#endif // __PYTHON_RULE_H__
