//  Clint - Source code checker for C++
//  Copyright (C) 2001  David Pashley
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include "message.h"
#include <iostream>

namespace clint {

   Messages msgs;

   Message::Message(std::string file, int line, std::string message, Level level) 
      : m_file(file), m_line(line), m_message(message), m_level(level) {}

   std::ostream & operator << (std::ostream & out, const Message msg) {
      out << msg.m_file << ":" << msg.m_line;
      switch (msg.m_level) {
         case ERROR:
            out << ":E: ";
            break;
         case WARNING: 
            out << ":W: ";
            break;
      }
      out << msg.m_message;
      return out;
   }
   
   bool operator< (const Message a, const Message b) {
      return a.m_file < b.m_file or  a.m_line < b.m_line; 
   }

   std::ostream & operator << (std::ostream & out, const Messages msgs) {
      for (Messages::const_iterator msg = msgs.begin(); msg < msgs.end(); ++msg ) {
         out << *msg << std::endl;
      }
      return out;
   }

}
