//  Clint - Source code checker for C++
//  Copyright (C) 2001  David Pashley
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __PLUGIN_H__ 
#define __PLUGIN_H__

#include <vector> 
#include <string>
#include "rule.h"

// base class for all shapes 
class Plugin { 
   public:
      virtual void initialize()=0;
      virtual void finalize()=0;
      // TODO add a RuleList as a member and get use load_rules to fill
      // that list and then use register_rules to copy them into the
      // main list
      virtual void register_rules(RuleList & rules)=0;
};

// our global factory 
extern std::vector<Plugin *> plugins;

#endif // __PLUGIN_H__

//! \todo Create a REGISTER macro to ease registering plugins. 
