//  Clint - Source code checker for C++
//  Copyright (C) 2001  David Pashley
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __RULE_H__
#define __RULE_H__

#include <string>
#include <vector>

class Rule {
   public:
      Rule();
      virtual ~Rule();
      virtual void initialize() = 0;
      virtual void finalize() = 0;
      virtual void pre_cpp(const std::string line) = 0;
      virtual void post_cpp(const std::string line) = 0;
};

typedef std::vector<Rule *> RuleList;

#endif // __RULE_H__
